--[[
	Project: zBag
	Version: 1.0
	Author: Zoc ( http://www.riftui.com/forums/member.php?u=1215 )
	
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
]]

local context = UI.CreateContext("zBagContext")
local zBagWindow = UI.CreateFrame("SimpleWindow", "zBag", context)
local closeButton = UI.CreateFrame("Texture", "zBagCloseButton", zBagWindow)
zBagWindow:SetTitle("Inventory")

local zBagIcons = {}

--------------------------------------------------------------------
-- UI Setup
local function Init()

	-- TODO: Make these configurable
	zBagWindow:SetVisible(false)
	zBagWindow:SetWidth(600)
	zBagWindow:SetPoint("CENTER", UIParent, "CENTER")

	-- The close button actually hides the frame ;)
	closeButton:SetTexture("zBag", "textures/close.png")
	closeButton:SetPoint("TOPRIGHT", zBagWindow, "TOPRIGHT", -8, 16)	
	function closeButton.Event:LeftClick()
--		inputSearchField:SetKeyFocus(false) -- Future item search ?
		zBagWindow:SetVisible(false)
	end

	print ("zBag Initialized")


-- This debug request always returns null (at least on /reloadui). It seems the item data is only initialized after the addons are.
--	icontext = Inspect.Item.Detail( Utility.Item.Slot.Inventory( 1,1 ) )["icon"]
--	print(icontext)
--	item1:SetTexture("Rift", icontext )

end

--------------------------------------------------------------------
-- UI Functions
local iconPadding = 7
local startX = 30
local startY = 65
local iconWidth = 48

-- Debug, need to clean up the code.
local function DisplayInventoryItems()
	zBagIcons = {}
	local currentX = startX
	local currentY = startY
	
	for bagNumber = 1, 5 do
		-- Create new array for the current bag.
		zBagIcons[bagNumber] = {}
		
		if ( Inspect.Item.Detail( Utility.Item.Slot.Inventory( "bag", bagNumber ) ) ~= nil ) then
			bagSize = Library.LibItemWidget.GetBagSize( bagNumber )
			
			-- Loop through all the items in the bag
			for i=1, bagSize do
				-- Create new ItemIcon for the current Item
				zBagIcons[bagNumber][i] = UI.CreateFrame("ItemIcon", "zbagicon" .. i, zBagWindow)
				
				-- Set the desired position and update next icon position
				zBagIcons[bagNumber][i]:SetPoint("TOPLEFT", zBagWindow, "TOPLEFT", currentX, currentY)
				currentX = currentX + iconPadding + iconWidth

				-- Check if it fits the window
				if( ( currentX + iconPadding + iconWidth ) >=  zBagWindow:GetWidth() ) then
					currentX = startX
					currentY = currentY + iconPadding + iconWidth
				end

				-- Set the item
				zBagIcons[bagNumber][i]:SetBagPosition( bagNumber, i )
			end
		end
	end
	
	if ( currentX == startX ) then
		zBagWindow:SetHeight( currentY + iconWidth/2 )
	else
		zBagWindow:SetHeight( currentY + iconPadding + iconWidth + iconWidth/2 )
	end
	
	zBagWindow:SetVisible(true)
end

local function DisplayInventory()
	DisplayInventoryItems()
-- Maybe in future ?
--	DisplayMoney()
end

table.insert(Command.Slash.Register("di"), {DisplayInventory, "zBag", "di"})

Init()
